'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _tracekit = require('tracekit');

var _tracekit2 = _interopRequireDefault(_tracekit);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('../api/logs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_module2.default.constant('AV_EXCEPTIONS', {
  MESSAGES: {
    NOT_APPLICABLE: 'N/A'
  },
  TYPES: {
    EXCEPTION: 'exception'
  },
  REPEAT_LIMIT_TIME: 5000
});

var AvExceptionAnalyticsProvider = function () {
  function AvExceptionAnalyticsProvider() {
    _classCallCheck(this, AvExceptionAnalyticsProvider);

    this._enabled = true;
    this.appId;
  }

  _createClass(AvExceptionAnalyticsProvider, [{
    key: 'enabled',
    value: function enabled(_enabled) {
      this._enabled = !!_enabled;
    }
  }, {
    key: 'setAppId',
    value: function setAppId(_id) {
      this.appId = _id;
    }
  }, {
    key: '$get',
    value: function $get($location, AV_EXCEPTIONS, $injector) {

      var that = this;

      var AvExceptionAnalytics = function () {
        function AvExceptionAnalytics() {
          _classCallCheck(this, AvExceptionAnalytics);
        }

        _createClass(AvExceptionAnalytics, [{
          key: 'init',
          value: function init() {

            var self = this;

            if (!that._enabled) {
              return;
            }

            _tracekit2.default.remoteFetching = false;
            _tracekit2.default.surroundingLinesToCollect = 11;

            // subscribe() hooks into window.error
            _tracekit2.default.report.subscribe(function (stacktrace) {
              self.onError(stacktrace);
            });

            this.messageTimestampMap = {};
          }
        }, {
          key: 'prettyPrint',
          value: function prettyPrint() {
            var stacktrace = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


            var message = '';

            try {
              if (!stacktrace.stack) {
                stacktrace.stack = new Error('force-added stack').stack;
                if (stacktrace.stack) {
                  stacktrace.stack = stacktrace.stack.toString();
                }
              }
            } catch (e) {/* throw away */}

            var length = stacktrace.stack ? stacktrace.stack.length : 0;

            for (var i = 0; i < length; i++) {
              var iMessage = i.toString();
              while (iMessage.length < 2) {
                iMessage = '0' + iMessage;
              }
              message += ['[' + iMessage + '] ', stacktrace.stack[i].func, ' ', stacktrace.stack[i].url, ':', stacktrace.stack[i].line, ':', stacktrace.stack[i].column, i + 1 < length ? '\n' : ''].join('');
            }

            return message;
          }
        }, {
          key: 'onError',
          value: function onError(stacktrace) {

            var userAgent = window.navigator && window.navigator.userAgent ? window.navigator.userAgent : AV_EXCEPTIONS.MESSAGES.NOT_APPLICABLE;

            var message = {
              errorDate: (0, _moment2.default)(new Date()).format('YYYY-MM-DDTHH:mm:ssZZ'),
              errorName: stacktrace.name,
              errorMessage: stacktrace.message,
              errorStack: this.prettyPrint(stacktrace),
              url: $location.$$absUrl,
              appId: that.appId || AV_EXCEPTIONS.MESSAGES.NOT_APPLICABLE,
              appVersion: APP_VERSION || AV_EXCEPTIONS.MESSAGES.NOT_APPLICABLE,
              userAgent: userAgent,
              userLanguage: navigator.userLanguage,
              referrer: document.referrer,
              host: document.domain,
              screenWidth: (0, _jquery2.default)(window).width(),
              screenHeight: (0, _jquery2.default)(window).height(),
              sdkVersion: process.env.VERSION
            };

            return this.log(message);
          }
        }, {
          key: 'log',
          value: function log(message) {
            var avLogMessagesResource = $injector.get('avLogMessagesResource');
            return avLogMessagesResource.error(message);
          }
        }, {
          key: 'trackEvent',
          value: function trackEvent(exception) {

            if (!that._enabled) {
              return null;
            }

            // If we've already logged this error recently, don't log it again (no need to spam the API)
            if (this._isRepeatError(exception)) {
              return;
            }

            var stacktrace = _tracekit2.default.computeStackTrace(exception);

            return this.onError(stacktrace);
          }

          // Check to see if this error was reported within the last 5 seconds

        }, {
          key: '_isRepeatError',
          value: function _isRepeatError(exception) {
            var timestamp = (0, _moment2.default)();
            var message = exception.message;
            var lastTimestamp = this.messageTimestampMap[message];
            var isRepeat = false;

            if (lastTimestamp && timestamp.diff(lastTimestamp) < AV_EXCEPTIONS.REPEAT_LIMIT_TIME) {
              isRepeat = true;
            }

            this.messageTimestampMap[message] = timestamp;
            return isRepeat;
          }
        }]);

        return AvExceptionAnalytics;
      }();

      return new AvExceptionAnalytics();
    }
  }]);

  return AvExceptionAnalyticsProvider;
}();

_module2.default.provider('avExceptionAnalytics', AvExceptionAnalyticsProvider);

_module2.default.config(function ($provide) {

  $provide.decorator('$exceptionHandler', function ($delegate, $injector) {

    return function (exception, cause) {
      $delegate(exception, cause);
      var errorTacking = $injector.get('avExceptionAnalytics');
      errorTacking.trackEvent(exception);
    };
  });
});

_module2.default.run(function (avExceptionAnalytics) {
  return avExceptionAnalytics.init();
});

exports.default = _module2.default;