'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_module2.default.factory('avAnalyticsUtils', function (avAnalyticsConfig, $log) {
  var AnalyticsUtils = function () {
    function AnalyticsUtils() {
      _classCallCheck(this, AnalyticsUtils);
    }

    _createClass(AnalyticsUtils, [{
      key: 'getProperties',
      value: function getProperties(attributes) {

        var self = this;
        var props = {};

        Object.keys(attributes).forEach(function (key) {
          if (self.isValidAttribute(key) && self.isNotIgnored(key)) {
            var result = self.getAttribute(key, attributes[key]);
            props[result.key] = result.value;
          }
        });

        return props;
      }

      // Function detects external links in order to allow the analytics framework to run
      // before the browser follows a link.
      //
      //    - target="_self" - This opens an anchor in the same frame
      //    - target="_parent" - Opens the in the next level up of a frame if they were nested to inside one another
      //    - target="_top" - Opens the link as top document in the browser window
      //    - target="_blank" - Opens link in new tab new tab
      //

    }, {
      key: 'isExternalLink',
      value: function isExternalLink(attrs) {
        return attrs.href && !attrs.ngClick;
      }
    }, {
      key: 'isNotIgnored',
      value: function isNotIgnored(key) {
        var ignored = avAnalyticsConfig.IGNORE.indexOf(key) > -1;
        return !ignored;
      }
    }, {
      key: 'isValidAttribute',
      value: function isValidAttribute(key) {
        return avAnalyticsConfig.PRE_FIX.test(key);
      }
    }, {
      key: 'lowercase',
      value: function lowercase(str) {
        return str.substr(0, 1).toLowerCase() + str.substr(1);
      }
    }, {
      key: 'getAttribute',
      value: function getAttribute(key, value) {

        var simpleKey = key.match(avAnalyticsConfig.PRE_FIX);

        if (simpleKey && simpleKey[1]) {
          return {
            key: this.lowercase(simpleKey[1]),
            value: value
          };
        }
      }
    }, {
      key: 'toNum',
      value: function toNum(value) {
        var parsed = parseInt(value, 10);
        return isNaN(parsed) ? 0 : parsed;
      }
    }, {
      key: 'isValid',
      value: function isValid(trackingValues) {

        var valid = true;

        if (trackingValues.value || trackingValues.value === 0) {
          delete trackingValues.value;
        }

        Object.keys(trackingValues).forEach(function (key) {
          var value = trackingValues[key];
          if ((0, _utils.isBlank)(value) || _angular2.default.isUndefined(value)) {
            $log.warn('The analytic tracking value for ' + key.toUpperCase() + ' is not defined.');
            valid = false;
          }
        });

        return valid;
      }
    }]);

    return AnalyticsUtils;
  }();

  return new AnalyticsUtils();
});