'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Inspiration from https://github.com/McNull/angular-block-ui.
//
//  - Need npm compatible library
//  - Re-factor with better life-cycle hooks for starting and stopping animations

var BlockController = function () {
  function BlockController($element, avBlockManager, avBlockConfig, $attrs, $scope, $compile) {
    var _this = this;

    _classCallCheck(this, BlockController);

    this.av = { $element: $element, avBlockManager: avBlockManager, avBlockConfig: avBlockConfig, $attrs: $attrs, $scope: $scope, $compile: $compile };

    // Expose the blockMessageClass attribute value on the scope
    this.av.$attrs.$observe('blockMessageClass', function (value) {
      _this.av.$scope.$_blockMessageClass = value;
    });

    // Create the block instance
    // Prefix underscore to prevent integers:
    // https://github.com/McNull/angular-block-ui/pull/8

    this.instanceId = this.av.$attrs.avBlock || '_' + this.av.$scope.$id;
    this.serviceInstance = this.av.avBlockManager.get(this.instanceId);

    // Locate the parent block instance
    var parentInstance = this.av.$element.inheritedData('av-block');

    if (parentInstance) {
      this.serviceInstance._parent = parentInstance;
    }

    // Expose the state on the scope
    this.av.$scope.$_blockState = this.serviceInstance.state();

    this.av.$scope.$watch('$_blockState.blocking', function (value) {
      // Set the aria-busy attribute if needed
      _this.av.$element.attr('aria-busy', !!value);
      _this.av.$element.toggleClass('av-block-visible', !!value);
    });

    this.av.$scope.$watch('$_blockState.blockCount > 0', function (value) {
      _this.av.$element.toggleClass('av-block-active', !!value);
    });

    // If a pattern is provided assign it to the state
    var pattern = this.av.$attrs.blockPattern;

    if (pattern) {
      var regExp = (0, _utils.buildRegExp)(pattern);
      this.serviceInstance.pattern(regExp);
    }

    // Store a reference to the service instance on the element

    this.av.$element.data('av-block', this.serviceInstance);
  }

  _createClass(BlockController, [{
    key: 'moduleLoaded',
    value: function moduleLoaded(name) {

      try {
        _angular2.default.module(name);
      } catch (ex) {
        return false;
      }

      return true;
    }
  }, {
    key: 'registerLocationChange',
    value: function registerLocationChange() {

      this.av.$scope.$on('$locationChangeStart', function (event) {

        if (this.serviceInstance.$_blockLocationChange && this.serviceInstance.state().blockCount > 0) {
          event.preventDefault();
        }
      });

      this.av.$scope.$on('$locationChangeSuccess', function () {
        this.serviceInstance.$_blockLocationChange = this.serviceInstance.blockBrowserNavigation;
      });
    }
  }, {
    key: 'blockNavigation',
    value: function blockNavigation() {
      var _this2 = this;

      if (this.av.avBlockConfig.blockBrowserNavigation) {

        if (this.moduleLoaded('ngRoute')) {

          // After the initial content has been loaded we'll spy on any location
          // changes and discard them when needed.
          //
          var fn = this.av.$scope.$on('$viewContentLoaded', function () {

            // Unhook the view loaded and hook a function that will prevent
            // location changes while the block is active.

            fn();
            _this2.registerLocationChange();
          });
        } else {
          this.registerLocationChange();
        }
      }
    }

    // Ensure the instance is released when the scope is destroyed

  }, {
    key: '$destroy',
    value: function $destroy() {
      this.serviceInstance.release();
      this.av.$element.data('av-block', null);
    }
  }, {
    key: '$postLink',
    value: function $postLink() {

      this.container = this.av.$compile('<av-block-container class="av-block-container"></av-block-container >')(this.av.$scope);
      this.av.$element.append(this.container);

      // If the element does not have the class 'av-block' set, we set the
      // default css classes from the config.

      if (!this.av.$element.hasClass('av-block')) {
        this.av.$element.addClass(this.av.avBlockConfig.cssClass);
      }
    }
  }]);

  return BlockController;
}();

_module2.default.directive('avBlock', function () {
  return {
    scope: {},
    restrict: 'AE',
    controller: BlockController
  };
});