'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _lodash = require('lodash.findindex');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.matches');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.isempty');

var _lodash6 = _interopRequireDefault(_lodash5);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _utils = require('../../core/utils');

require('./provider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvDropdownController = function () {
  function AvDropdownController($element, $attrs, avDropdownConfig, $scope, $timeout, $parse) {
    _classCallCheck(this, AvDropdownController);

    this.av = { $element: $element, $attrs: $attrs, avDropdownConfig: avDropdownConfig, $scope: $scope, $timeout: $timeout, $parse: $parse };

    this.options = {};
    this.match = null;
    this.ngModel = null;
    this.locals = {};
  }

  _createClass(AvDropdownController, [{
    key: 'init',
    value: function init(context) {
      var _this = this;

      this.ngModel = context.ngModel;

      this.multiple = _angular2.default.isDefined(this.av.$attrs.multiple);

      this.options = _angular2.default.extend({}, this.av.avDropdownConfig.DEFAULTS, this.av.$scope.$eval(this.av.$attrs.options));

      if (this.isRemoteMultiple()) {
        this.options.multiple = _angular2.default.isDefined(this.av.$attrs.multiple);
      }

      if (this.options.query) {

        // Map AvSelectResource into Select2 options
        this.resource = this.options.query;

        // Function used to query results for the search term.
        this.options.query = function (options) {
          options.params = _this.options.params;
          _this.query(options);
        };
        // Function used to get the id from the choice object or a string representing the key under which the id is stored.
        this.options.id = this.resource.getId;
        this.options.initSelection = this.resource.initSelection;
      }

      // if element is type input, initSelection is required to use val
      if (!this.av.$element.is('select') && !this.options.initSelection) {
        this.options.initSelection = this.initSelection;
      }
    }
  }, {
    key: 'isRemoteMultiple',
    value: function isRemoteMultiple() {
      return _angular2.default.isDefined(this.av.$attrs.multiple) && this.av.$element.get(0).tagName.toLowerCase() === 'input';
    }
  }, {
    key: 'initSelection',
    value: function initSelection(element, callback) {
      callback();
    }
  }, {
    key: 'setRemoteViewValue',
    value: function setRemoteViewValue(e) {

      var values = this.ngModel.$viewValue;

      if (!_angular2.default.isArray(values) || !_angular2.default.isObject(values)) {
        values = [];
      }

      if (e.added) {
        // Adding to collection
        values.push(e.added);
      } else {
        // Removing from collection
        var index = (0, _lodash2.default)(values, function (value) {
          return (0, _lodash4.default)(e.removed)(value);
        });
        values.splice(index, 1);
      }

      this.ngModel.$setViewValue(values);
    }
  }, {
    key: 'setViewValue',
    value: function setViewValue(e) {
      this.ngModel.$setViewValue(e.added);
    }
  }, {
    key: 'hashKey',
    value: function hashKey(obj, nextUidFn) {
      var key = obj && obj.$$hashKey;

      if (key) {
        if (typeof key === 'function') {
          key = obj.$$hashKey();
        }
        return key;
      }

      var objType = typeof obj === 'undefined' ? 'undefined' : _typeof(obj);
      if (objType === 'function' || objType === 'object' && obj !== null) {
        key = obj.$$hashKey = objType + ':' + (nextUidFn || _utils.uuid)();
      } else {
        key = objType + ':' + obj;
      }

      return key;
    }
  }, {
    key: 'getTrackByValueFn',
    value: function getTrackByValueFn(value, locals) {

      if (this.trackBy) {
        return this.trackByFn(this.av.$scope, locals);
      }

      return this.hashKey(value);
    }
  }, {
    key: 'getSelected',
    value: function getSelected(model) {
      var _this2 = this;

      var self = this;

      if (this.options.query) {
        return 0;
      }

      if (!this.collection) {
        // If we're not using ng-options, the model value is just the raw value of the option,
        // rather than an index, so return it as is.
        return model;
      }

      var optionValues = this.valuesFn(self.av.$scope) || [];
      var optionValuesKeys = this.getOptionValuesKeys(optionValues);

      var index = (0, _lodash2.default)(this.collection, function (item) {
        return _angular2.default.equals(model, item) || _angular2.default.isObject(item) && _this2.valueName && _angular2.default.equals(model, item[_this2.valueName]);
      });

      var key = optionValues === optionValuesKeys ? index : optionValuesKeys[index];
      var value = optionValues[key];
      var locals = self.getLocals(value, key);
      var viewValue = self.viewValueFn(self.av.$scope, locals);
      var selectValue = self.getTrackByValueFn(viewValue, locals);

      return selectValue;
    }
  }, {
    key: 'getMultiSelected',
    value: function getMultiSelected(viewValues) {

      var self = this;

      var values = [];

      if (!viewValues) {
        return values;
      }

      if (this.av.$element.get(0).tagName.toLowerCase() !== 'input') {

        viewValues.forEach(function (viewValue) {

          var selected = self.getSelected(viewValue);

          values.push(selected);
        });
      }

      return values;
    }

    // Wrapper around the query function for Select2.  When the promise resolves
    // the callback

  }, {
    key: 'query',
    value: function query(options) {

      this.resource.onQuery(options).then(function (response) {

        // Callback function that should be called with the result object. The result object:
        //
        // result.results (object) - Array of result objects. The default renderers
        //    expect objects with id and text keys. The id property is required,
        //    even if custom renderers are used. The object may also contain a children
        //    key if hierarchical data is displayed. The object may also contain a disabled
        //    boolean property indicating whether this result can be selected.
        //
        // result.more (boolean) - true if more results are available for the current
        //    search term.
        //
        // results.context (object) - A user-defined object that should be made available
        //    as the context parameter to the query function on subsequent queries to load
        //    more result pages for the same search term. See the description of
        //    options.context parameter.
        options.callback({ more: response.more, results: response.results });
      });
    }
  }, {
    key: 'setValue',
    value: function setValue() {
      var self = this;
      if (this.options.query) {
        var modelValue = this.ngModel.$modelValue;
        this.av.$timeout(function () {
          return self.av.$element.select2('data', modelValue);
        });
      } else {
        var viewValue = this.ngModel.$viewValue;

        var selected = null;
        if (this.multiple) {
          selected = this.getMultiSelected(viewValue);
        } else {
          selected = this.getSelected(viewValue);
        }

        // null === '' for Select2
        selected = selected === null || selected === 'undefined' ? '' : selected;

        this.av.$timeout(function () {
          return self.av.$element.select2('val', selected);
        });
      }
    }
  }, {
    key: 'setValues',
    value: function setValues() {
      var _this3 = this;

      if (this.options.query) {
        var modelValue = this.ngModel.$modelValue;
        this.av.$timeout(function () {
          return self.av.$element.select2('data', modelValue);
        });
      } else {
        var viewValue = this.ngModel.$viewValue;

        if (!_angular2.default.isArray(viewValue)) {
          viewValue = [];
        }

        if (!(0, _lodash6.default)(viewValue) && _angular2.default.isObject(viewValue[0])) {
          viewValue = this.getMultiSelected(viewValue);
        }

        this.av.$timeout(function () {
          return _this3.av.$element.select2('val', viewValue);
        });
      }
    }
  }, {
    key: 'ngOptions',
    value: function ngOptions() {
      var _this4 = this;

      this.match = this.av.$attrs.ngOptions.match(this.av.avDropdownConfig.NG_OPTIONS_REGEXP);
      if (!this.match) {
        throw new Error('Invalid ngOptions for avDropdown.  @See https://docs.angularjs.org/api/ng/directive/ngOptions');
      }

      // NG_OPTIONS_REGEXP regex will parse into arrays like below:

      // 1: value expression (valueFn)
      // 2: label expression (displayFn)
      // 3: group by expression (groupByFn)
      // 4: disable when expression (disableWhenFn)
      // 5: array item variable name
      // 6: object item key variable name
      // 7: object item value variable name
      // 8: collection expression
      // 9: track by expression

      // The variable name for the value of the item in the collection
      this.valueName = this.match[5] || this.match[7];

      // An expression that generates the viewValue for an option if there is no label expression
      this.valueFn = this.av.$parse(this.match[2] ? this.match[1] : this.valueName);

      // The variable name for the key of the item in the collection
      this.keyName = this.match[6];

      // An expression that generates the viewValue for an option if there is a label expression
      this.selectAs = / as /.test(this.match[0]) && this.match[1];

      // An expression that generates the viewValue for an option if there is a label expression
      // An expression that is used to track the id of each object in the options collection
      this.trackBy = this.match[9];
      this.selectAsFn = this.selectAs && this.av.$parse(this.selectAs);
      this.viewValueFn = this.selectAsFn || this.valueFn;
      this.trackByFn = this.trackBy && this.av.$parse(this.trackBy);

      this.displayFn = this.av.$parse(this.match[2] || this.match[1]);
      this.groupByFn = this.av.$parse(this.match[3] || '');
      this.disableWhenFn = this.av.$parse(this.match[4] || '');
      this.valuesFn = this.av.$parse(this.match[8]);
      this.collection = this.valuesFn(this.av.$scope);

      this.av.$scope.$watchCollection(this.match[8], function (newVal, oldVal) {
        if (_angular2.default.equals(newVal, oldVal)) {
          return;
        }
        _this4.collection = _this4.valuesFn(_this4.av.$scope);
        _this4.setValue();
      }, true);
    }
  }, {
    key: 'getLocals',
    value: function getLocals(value, key) {

      var locals = {};

      if (this.keyName) {
        locals[this.keyName] = key;
        locals[this.valueName] = value;
      } else {
        locals[this.valueName] = value;
      }

      return locals;
    }
  }, {
    key: 'getOptionValuesKeys',
    value: function getOptionValuesKeys(optionValues) {

      var optionValuesKeys = void 0;

      if (!this.keyName && Array.isArray(optionValues)) {
        optionValuesKeys = optionValues;
      } else {
        // if object, extract keys, in enumeration order, unsorted
        optionValuesKeys = [];
        for (var itemKey in optionValues) {
          if (optionValues.hasOwnProperty(itemKey) && itemKey.charAt(0) !== '$') {
            optionValuesKeys.push(itemKey);
          }
        }
      }
      return optionValuesKeys;
    }
  }]);

  return AvDropdownController;
}();

_module2.default.controller('AvDropdownController', AvDropdownController);

exports.default = AvDropdownController;