'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _organizationsSelect = require('./organizations-select.html');

var _organizationsSelect2 = _interopRequireDefault(_organizationsSelect);

require('./organizations-select-resource');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_module2.default.directive('avSelectOrganizations', function () {
  return {
    restrict: 'AE',
    replace: true,
    require: ['ngModel'],
    templateUrl: _organizationsSelect2.default,
    controller: function controller($scope, $parse, $attrs, avSelectOrganizationsResource) {
      var optionsFn = $parse($attrs.selectOptions);
      var options = optionsFn($scope);

      options = options || {};

      if (!options.params && !options.params.permissionIds && !options.dangerouslyIgnorePermissions) {
        throw new Error('Permissions IDs are required for av-select-organizations directive. To bypass the permissions constraint, set options.dangerouslyIgnorePermissions to true');
      }

      function defaults() {
        var defaultOptions = {

          allowClear: true,
          placeholder: 'Select an Organization',
          minimumInputLength: 0
        };
        return defaultOptions;
      }

      $scope.dropdownOptions = _angular2.default.merge(defaults(), options);
      $scope.dropdownOptions.query = avSelectOrganizationsResource;
    }
  };
});

exports.default = _module2.default;