'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvTooltipController = function () {
  function AvTooltipController($element, $scope, AV_TOOLTIP, $timeout, avTooltipConfig) {
    _classCallCheck(this, AvTooltipController);

    this.di = { $element: $element, $scope: $scope, AV_TOOLTIP: AV_TOOLTIP, $timeout: $timeout };
    this.options = _extends({}, avTooltipConfig);
  }

  _createClass(AvTooltipController, [{
    key: 'listeners',
    value: function listeners() {
      var _this = this;

      ['show', 'shown', 'hide', 'hidden'].forEach(function (name) {
        _this.di.$element.on(name + '.bs.tooltip', function (ev) {
          return _this.di.$scope.$emit('av:tooltip:' + name, ev);
        });
      });
    }
  }, {
    key: 'plugin',
    value: function plugin() {
      return this.di.$element.data(this.di.AV_TOOLTIP.NAME);
    }
  }, {
    key: 'show',
    value: function show() {
      this.di.$element.tooltip('show');
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.di.$element.tooltip('hide');
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.di.$element.tooltip('toggle');
    }
  }, {
    key: '$destroy',
    value: function $destroy() {
      this.di.$element.tooltip('destroy');
    }
  }, {
    key: 'init',
    value: function init() {
      this.listeners();

      if (this.di.$scope.show) {

        // give the UI a chance to settle first.
        this.di.$timeout(this.show.bind(this), 0, false);

        if (this.di.$scope.delay && this.di.$scope.delay.hide) {
          this.di.$timeout(this.hide.bind(this), this.di.$scope.delay.hide, false);
          return;
        }

        // If no delay is found or cannot be parsed, set a default timeout so that the tooltip doesn't stick around forever
        this.di.$timeout(this.hide.bind(this), this.options.showDelay, false);
      }
    }
  }]);

  return AvTooltipController;
}();

_module2.default.controller('AvTooltipController', AvTooltipController);